<?php
defined('_JEXEC') or die('Restricted access');

// Load the language
JPlugin::loadLanguage( 'plg_community_stuffs' );

class plgCommunityCommunity_stuffs extends JPlugin
{
	function plgCommunityCommunity_stuffs (&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onCustomUserList($client, $limitstart = 0, $limit = 0)
	{
		if($client!='community_stuffs'){return;}
		$db = &JFactory::getDBO();
		global $mainframe;
		$pathway 	= & $mainframe->getPathway();
	
		$stnid 				= JRequest::getInt('stnid');
		$search				= JRequest::getVar('search',			'',				'', 'word');
		$type				= JRequest::getVar('type',				0,				'', 'int');
		$returnurl			= JRequest::getVar('return',			'index.php',	'', 'string');
		
		$where = array();
		if ($search!='') $where[] = 'sn.name LIKE '.$db->Quote('%'.$search.'%');
		if ($type>0 && $type<5) $where[] = 'st.type='.$type;
		if ($stnid) $where[] = 'sn.id='.$stnid;
		$where = (count($where)>0) ? 'WHERE '.implode(' AND ',$where).' ' : '';

		$query = 'SELECT u.* FROM #__users AS u '
				.'LEFT JOIN #__community_stuffs AS st ON u.id=st.user_id '
				.'LEFT JOIN #__community_stuff_names AS sn ON st.stuff_name_id=sn.id '
				.$where
				.'GROUP BY u.id';
		$db->setQuery($query);
		$users = $db->loadObjectList();
		$return = new StdClass();
		$return->description = '<a href="'.base64_decode($returnurl).'">'.JText::_('Back').'</a>';
		$return->users = $users;
		$pathway->addItem(JText::_('STUFFS'));

		return $return;		
	}
	
	function onProfileExtra($user, $params = null, $name)
	{
		if ($name != 'community_stuffs'){return;}
		$task = JRequest::getCmd("cspl", null);
		switch ($task) {
			case 'details' : $out_text = $this->showStuffDetails($user); break;
			case 'delete' : 
				// delete the stuff
				$nowuser = & JFactory::getUser();
				if ($user->id!=$nowuser->id) {
					global $mainframe;
					$mainframe->redirect('index.php?&option=com_community','You\'re not authorized to view this page!');
					return 0;
				}

				$stid = JRequest::getCmd('stid');
				$db = & JFactory::getDBO();
				
				$db->setQuery('SELECT picture FROM #__community_stuffs WHERE id='.$stid);
				$pictname = $db->loadResult();
				
				// delete the picture of the stuff
				jimport('joomla.filesystem.file');
				JFile::delete(JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.$user->id.DS.'stuffs'.DS.'thumbnails.'.DS.$pictname);
				JFile::delete(JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.$user->id.DS.'stuffs'.DS.'original.'.DS.$pictname);

				// from database
				$db->setQuery('DELETE FROM #__community_stuffs WHERE id='.$stid);
				$db->query();
				
				$out_text = $this->showStuffs($user); break;
			case 'saves' : 
				$nowuser = & JFactory::getUser();
				if ($user->id!=$nowuser->id) {
					global $mainframe;
					$mainframe->redirect('index.php?&option=com_community','You\'re not authorized to view this page!');
					return 0;
				}			
				$out_text = $this->saveStuff($user);
			default: $out_text = $this->showStuffs($user); break;
		}

		$ret = new JSCommunityTab();
		$ret->name  = 'community_stuffs';
		$ret->title = JText::_("User Stuffs");
		$ret->text  = $out_text;
		
		return $ret;
	}
	
	function saveStuff($user)
	{
		$file 		= JRequest::getVar( 'pict', '', 'files', 'array' );
		$type		= JRequest::getVar('type',   0, '',  		'int');
		$name		= JRequest::getVar('name',   0, '',			'int');
		if (!$name || $name==0) 
		$name		= JRequest::getVar('textname','', '',		'string');
		$price		= JRequest::getVar('price',	 0, '',			'int');
		$note		= JRequest::getVar('note',	 '', '',		'string');
		 
		jimport('joomla.filesystem.file');
		$file['name']	= JFile::makeSafe($file['name']);
		
		$date = new JDate();

		if (isset($file['name'])) {
			$filepath = JPath::clean(JPATH_ROOT.DS.'components'.DS.'com_community_stuffs'.DS.'images'.DS.strtolower($file['name']));

			if (JFile::exists($filepath)) {
				if ($format == 'json') {
					jimport('joomla.error.log');
					$log = &JLog::getInstance('upload.error.php');
					$log->addEntry(array('comment' => 'File already exists: '.$filepath));
					header('HTTP/1.0 409 Conflict');
					jexit('Error. File already exists');
				} else {
					JError::raiseNotice(100, JText::_('Error. File already exists'));
					// REDIRECT
					if ($return) {
						$mainframe->redirect(base64_decode($return).'&folder='.$folder);
					}
					return;
				}
			}

			if (!JFile::upload($file['tmp_name'], $filepath)) {
				if ($format == 'json') {
					jimport('joomla.error.log');
					$log = &JLog::getInstance('upload.error.php');
					$log->addEntry(array('comment' => 'Cannot upload: '.$filepath));
					JError::raiseWarning(100, JText::_('Please, select a picture!'));
					return;
				} else {
					JError::raiseWarning(100, JText::_('Please, select a picture!'));
					return;
				}
			} else { 
				// add to database 
				
				$db = & JFactory::getDBO();
				if (!is_int($name)) {
					$db->setQuery('INSERT INTO #__community_stuff_names (name, description) VALUES ('.$db->Quote($name).',\'\') ');
					$db->query();
					$db->setQuery('SELECT id FROM #__community_stuff_names WHERE name='.$db->Quote($name));
					$name = $db->loadResult();
				}
				$query = 'INSERT INTO #__community_stuffs (user_id, stuff_name_id, type, picture, price, note, date)'
						.'VALUES ('.$user->id.','.$name.','.$type.','.$db->Quote($file['name']).','.$price.','.$db->Quote($note).','.$db->Quote($date->toMySQL()).')';
				$db->setQuery($query);
				$db->query();
				JSCommunityApi::registerActivity(null, JText::_('Added a stuff '), $user->id, 'components/com_community/images/editprofile.png');
				
				$this->iconResize($file['name'], $filepath, $this->params->get('thumbnail_width'), $this->params->get('thumbnail_height'), 99, $file['type'], $user->id, 'thumbnails');
				$this->iconResize($file['name'], $filepath, $this->params->get('picture_width'), $this->params->get('picture_height'), 99, $file['type'], $user->id, 'original');
				
				JFile::delete($filepath);
			}
		}
		
		return $ht;
	}
	
	function getAddForm($user, &$doc)
	{
		$uri = JFactory::getURI();
		$url = $uri->toString();
		$url = preg_replace('/(&cspl)=(\w*)/', '', $url);
		$url.= '&cspl=saves';

		// add the stuff names
		$db = & JFactory::getDBO();
		$db->setQuery('SELECT name FROM #__community_stuff_names ORDER BY id ASC');
		$names = $db->loadResultArray();
		$db->setQuery('SELECT id FROM #__community_stuff_names ORDER BY id ASC');
		$ids = $db->loadResultArray();
		if (count($names)>0) $names = 'wl = ["'.implode('","',$names).'"];'.
									  'ids = ['.implode(',',$ids).'];';
		else $names = '';
		$doc->addScriptDeclaration( $names );
		
		// JS
		$js = '<script type="text/javascript">';
		$js.= 'var as = new AutoSuggest("textname", null);	';
		$js.= '</script>';
		
		// type pulldown
		$type = '<select name="type" id="type">';
		$type.= '<option value="1">'.$this->params->get('type1', JText::_('TYPE1')).'</option>';
		$type.= '<option value="2">'.$this->params->get('type2', JText::_('TYPE2')).'</option>';
		$type.= '<option value="3">'.$this->params->get('type3', JText::_('TYPE3')).'</option>';
		$type.= '<option value="4">'.$this->params->get('type4', JText::_('TYPE4')).'</option>';
		$type.= '</select>';
	
		$ht = "\n".'<div style="display:none;" id="addform">';
		$ht.= '<fieldset><legend>'.JText::_('ADDSTUFF').'</legend>';
		$ht.= '<table width=300px><form action="'.$url.'" method="post" id="formadd" name="formadd" enctype="multipart/form-data">';
		$ht.= '<tr><td><label for="textname">'.JText::_('NAME').'</label></td><td>';
		$ht.= '<input type="text" name="textname" id="textname" size="50" maxlength="50" onChange=""/></td></tr>';
		$ht.= '<tr><td><label for="file-upload">'.JText::_('PICTURE').'</label></td><td>';
		$ht.= '<input type="file" id="file-upload" name="pict"/></td></tr>';
		$ht.= '<tr><td><label for="price">'.JText::_('PRICE').'</label></td><td>';
		$ht.= '<input type="text" id="price" name="price" size="5" maxlength="5"/></td></tr>';
		$ht.= '<tr><td><label for="note">'.JText::_('NOTE').'</label></td><td>';
		$ht.= '<textarea name="note"></textarea></td></tr>';
		$ht.= '<tr><td><label for="type">'.JText::_('TYPE').'</label></td><td>';
		$ht.= $type.'</td></tr>';
		$ht.= '<tr><td colspan=2><input type="submit" value="'.JText::_('ADD').'"/></td></tr>';
		$ht.= '<input type="hidden" id="name" name="name" value="0"/>';
		$ht.= '</form></table>';
		$ht.= '</fieldset></div>'."\n";
		
		$ht.= $js;
		return $ht;
	}
	
	function showStuffDetails($user)
	{
		$stid = JRequest::getCmd('stid');
		
		// get the stuff names from database
		$db = & JFactory::getDBO();		
		$db->setQuery("SELECT id, name, description FROM #__community_stuff_names");
		$stns = $db->loadObjectList();
		$stnm = array();
		foreach($stns as $stn) {
			$stnm[$stn->id]['n'] = $stn->name;
			$stnm[$stn->id]['d'] = $stn->description;
		}
				
		// get the stuf from database
		$db->setQuery("SELECT * FROM #__community_stuffs WHERE id = ".$stid);
		$stf = $db->loadObject();
		
		$ht = '<div style="padding:10px; border:1px;">';
		$ht .= '<table width=100%>';
		$ht .= '<tr><td>';
		$ht .= '<img src="'.JURI::root().COMMUNITY_GENERAL_UPLOAD.'/'.$user->id.'/stuffs/original/'.$stf->picture.'" alt="'.$stnm[$stf->stuff_name_id]['n'].'">';
		$ht .= '</td><td>';
		$ht .= '<table>';
		$ht .= '<tr><td colspan=2><span class="contentheading">'.JText::_('DETAILS').'</span></td></tr>';
		$ht .= '<tr><td width=100px>'.JText::_('NAME').':</td><td>'.$stnm[$stf->stuff_name_id]['n'].'</td></tr>';
		$ht .= '<tr><td>'.JText::_('PRICE').':</td><td>'.$stf->price.'</td></tr>';
		$ht .= '<tr><td>'.JText::_('NOTE').':</td><td>'.$stf->note.'</td></tr>';
		$ht .= '<tr><td>'.JText::_('DATE').':</td><td>'.$stf->date.'</td></tr>';
		$ht .= '<tr><td colspan=2><span class="contentheading">'.$this->params->get('type'.$stf->type, JText::_('TYPE'.$stf->type)).'</span></td></tr>';
		$ht .= '</table>';
		$ht .= '</td><tr></table></div>';
		
		return $ht;
	}
	
	function showStuffs($user)
	{
		// include javascript file
		$doc = & JFactory::getDocument();
		$doc->addScript(JURI::root().'/plugins/community/assets/autocomplete.js');
		$doc->addScript(JURI::root().'components/com_community/js/shadowbox/adapter/shadowbox-base.js');
		$doc->addScript(JURI::root().'components/com_community/js/shadowbox/shadowbox.js');
		$doc->addStyleSheet(JURI::root().'/plugins/community/assets/autosuggest.css');
		JHTML::_('behavior.tooltip');

		$uri = JFactory::getURI();
		$url = $uri->toString();		

		// get the stuff names from database
		$db = & JFactory::getDBO();		
		$db->setQuery("SELECT id, name FROM #__community_stuff_names");
		$stns = $db->loadObjectList();
		$stnm = array();
		foreach($stns as $stn) {
			$stnm[$stn->id] = $stn->name;
		}
		
		// get the stufs from database
		$userids = 'SELECT sn.id AS nameid, sn.name, st.*, st.id AS stid '
				.'FROM #__community_stuffs AS st '
				.'LEFT JOIN #__community_stuff_names AS sn ON sn.id=st.stuff_name_id '
				.$where
				;
		
		$usernums = 'SELECT sn.id AS nameid, COUNT(st.user_id) AS usernum '
				.'FROM #__community_stuffs AS st '
				.'LEFT JOIN #__community_stuff_names AS sn ON sn.id=st.stuff_name_id '
				.'GROUP BY nameid '
				;
		$query = 'SELECT userids.* , usernums.usernum '
				."FROM ({$userids}) AS userids "
				."LEFT JOIN ({$usernums}) AS usernums ON userids.nameid=usernums.nameid "
				.'HAVING user_id = '.$user->id.' '
				.'ORDER BY name '
				;
		$db->setQuery($query);
		$stfs = $db->loadObjectList();

		// distribute according to stuff types
		$ms = array();
		$iw = array();
		$ig = array();
		$is = array();
		if (count($stfs)>0)
		foreach ($stfs as $stf) {
			switch ($stf->type) {
				case 1: $ms[] = $stf; break;
				case 2: $iw[] = $stf; break;
				case 3: $ig[] = $stf; break;
				case 4: $is[] = $stf; break;
				default: break;
			}
		}		

		// prepare the pane
		require_once (JPATH_LIBRARIES.DS.'joomla'.DS.'html'.DS.'pane.php');
		$pane = new JPaneTabs();
		$params = array();
		$pane->_loadBehavior($params);

		$ht = $pane->startPane(JText::_("STUFFS"));
		
		// get the addform
		$addform = $this->getAddForm($user, $doc);
		// showall link
		$showall = '<img src="'.JURI::root().'components/com_community/images/show_all.png'.'"/>';		
		$itid = $this->params->get('item_itemid', null);
		$itid = ($itid) ? $itid : JRequest::getInt('Itemid');
		$showall.= '<a href="index.php?option=com_community_stuffs&user_id='.$user->id.'&Itemid='.$itid.'">'.JText::_('SHOWALL').'</a>';
		
		$nowuser = & JFactory::getUser();
		$auth = ($user->id==$nowuser->id);
		$url = preg_replace('/(&cspl)=(\w*)/', '', $url);
		
		// Tabs
		$this->getStuffList($auth, $stnm, $ms, $url, $ht, $pane, 1, $showall, $user->id);
		$this->getStuffList($auth, $stnm, $iw, $url, $ht, $pane, 2, $showall, $user->id);
		$this->getStuffList($auth, $stnm, $ig, $url, $ht, $pane, 3, $showall, $user->id);
		$this->getStuffList($auth, $stnm, $is, $url, $ht, $pane, 4, $showall, $user->id);
	
	/*
		$ht .= $pane->startPanel($add,"5");
		$ht .= $pane->endPanel();
		$ht .= $pane->startPanel($showall,"6");
		$ht .= $pane->endPanel();
	*/
		$ht .= $pane->endPane();
		$ht .= $addform;
		$root = JURI::root();
		$ht .= "
		<script type=\"text/javascript\">
			Shadowbox.loadSkin( 'classic', '{$root}components/com_community/js/shadowbox/skin' ); 
			Shadowbox.loadLanguage( 'en', '{$root}components/com_community/js/shadowbox/lang' ); 
			Shadowbox.loadPlayer( [ 'iframe' ], '{$root}components/com_community/js/shadowbox/player' );

			window.onload = Shadowbox.init;
			</script>
		";
		
		return $ht;
	}
	
	function getStuffList($auth, $stnm, $ms, $url, &$ht, &$pane, $type, $showall, $uid)
	{
		$add = '<img src="'.JURI::root().'components/com_community/images/add_new.png'.'"/>';
		$add.= '<a href="javascript:void(0);" onclick="showAddForm('.$type.');">'.JText::_('ADD').'</a>';
	
		$lim = $this->params->get('stuffsintab_limit');
		$msnum = count($ms);
		$ht.= $pane->startPanel($this->params->get('type'.$type, JText::_('TYPE'.$type)).' ('.$msnum.')', $type);
		$ht.= '<table width="100%">';
		$ht.= '<tr><td><div style="float:right; padding: 3px;">';
		$ht.= ($auth) ? $add : '';
		$ht.= '&nbsp;&nbsp;';
		$ht.= ($lim<$msnum) ? $showall : '';
		$ht.= '</div></td></tr><tr><td>';
		$ht.= '<div id="addt'.$type.'">';
		$ht.= '</div>';
		$ht.= '<div id="TYPE'.$type.'">';
		if (count($ms)>0) {
		$i = 0;
		foreach ($ms as $m) {
			$i++;
			if ($i<=$lim) {
				preg_match('/([\H|\s]*)(stid)=(\d+)([\H|\s]*)/', $url, $match);
				if ($match[3]>0) {
					$urldet = preg_replace('/([\H|\s]*)(stid)=(\d+)([\H|\s]*)/', '$1$2='.$m->id.'$4', $url);
				} else {
					$urldet = $url.'&stid='.$m->id;
				}
				$urldet = preg_replace('/(&cspl)=(\w+)/', '', $urldet);
				$urldel = $urldet.'&cspl=delete';
				$urldet = $urldet.'&cspl=details';	
				$urluserlist = JRoute::_('index.php?option=com_community&view=customlist&client=community_stuffs&stnid='.$m->nameid.'&return='.base64_encode($url).'&Itemid='.COMMUNITY_GENERAL_PROFILE_ITEMID);
			
				$ht .= '<div style="float:left; padding:5px; text-align:center;">';
				$ht .= '<table height="'.$this->params->get('thumbnail_height').'"><tr><td rowspan=2>';
				$ht .= '<span class="editlinktip hasTip" title="'.JText::_('Note').'::'.$m->note.'">';
				$ht .= '<a title="'.$stnm[$m->stuff_name_id].'" href="index.php?option=com_community_stuffs&view=stuff_details&stid='.(int)$m->id.'&tmpl=component" rel="shadowbox;width=500;height=400;">';
				$ht .= '<img src="'.JURI::root().COMMUNITY_GENERAL_UPLOAD.'/'.$uid.'/stuffs/thumbnails/'.$m->picture.'"/>';
				$ht .= '</a></span>';
				$ht .= '</td><td height="10px" width="10px">';
				if ($auth)
				$ht .= '<a href="'.$urldel.'"><img src="'.JURI::root().'components/com_community/images/publish_x.png" alt="delete"/></a>';
				$ht .= '</td></tr><tr><td></td></tr><tr><td>';
				$ht .= '<span>'.JText::_("NAME").':'.$stnm[$m->stuff_name_id].'&nbsp;(<a href="'.$urluserlist.'">'.$m->usernum.'</a>)</span>';
				$ht .= '<br/><span>'.JText::_("PRICE").':'.$m->price.'</span>';
				$ht .= '</td><td></td></tr></table>';
				$ht .= '</div>';
			}
		}}
		$ht.= '</div>';
		$ht.= '</td></tr></table>';
		$ht .= $pane->endPanel();
	}
	
	function onUserSlideMenu($user)
	{
		$link_place = $this->params->get('link_place');
		if ($link_place == 'Always' || $link_place == 'SlideMenu') {
			$Itemid = $this->params->get('item_itemid', JRequest::getInt('Itemid'));
			$menu->link = JRoute::_("index.php?option=com_community&view=profile&user_id={$user->id}");
			$menu->icon="plugins/community/icons/comments.png";
			$menu->alt = JText::_("Stuffs");
			return $menu;
		}
	}

	function onProfileMenu($user)
	{
		$link_place = $this->params->get('link_place');
		if ($link_place == 'Always' || $link_place == 'ProfileExtra') {
			$uri =& JFactory::getURI();
			$url = $uri->toString();
			$url = preg_replace('/(&cspl)=(\w+)/', '', $url);
		
			$menu = new stdClass();
			$menu->link = $url;
			$menu->icon	= "plugins/community/jsinbox_icon.png";
			$menu->alt 	= JText::_("STUFFS");
			$menuItems[] = $menu;
			$ret = new stdClass();
			$ret->menuItems = $menuItems;
			return $ret;
		}
	}

	function iconResize($name, $file, $max_width, $max_height, $quality, $app, $user_id, $type = 'original') {
		global $mainframe;

		$user = &JFactory::getUser();

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$file = JPath::clean($file);

		$folder = JPATH_ROOT.DS.COMMUNITY_GENERAL_UPLOAD.DS.$user_id;
		if(!JFolder::exists($folder))
		{
			if(!JFolder::create($folder))
			{	
				JError::raiseWarning(500, JText::_('Cannot Create directory'), $folder);
				return false;
			}
		}

		$folder .= DS.'stuffs';
		if(!JFolder::exists($folder))
		{
			if(!JFolder::create($folder))
			{
				JError::raiseWarning(500, JText::_('Cannot Create directory'), $folder);
				return false;
			}
		}
		$folder .= DS.$type;
		if(!JFolder::exists($folder))
		{
			if(!JFolder::create($folder))
			{
				JError::raiseWarning(500, JText::_('Cannot Create directory'), $folder);
				return false;
			}
		}

		$size = getimagesize($file);
		//exit;
		if(($size[0] <= $max_width) && ($size[1] <= $max_height))
		{
			JError::raiseNotice(01, "No Resize Needed");
			if(!JFile::exists($folder.DS.$name)) JFile::copy($file, $folder.DS.$name);
			return;
		}

		if(($size[0] > $max_width) && ($size[0] > $size[1]))
		{
			$width  = $max_width;
			$k = $size[0] / $max_width;
			$height = ($size[1] / $k);
		} else {
			$width  = $size[0];
			$height = $size[1];
		}

		if($height > $max_height)
		{
			$k = $height / $max_height;
			$height = $max_height;
			$width = ($width / $k);
		}


		$width  = round($width);
		$height = round($height);

		switch(strtolower($app))
		{
			case "image/gif":
				$img = imagecreatefromgif($file);
				break;
			case "image/png":
				$img = imagecreatefrompng($file);
				break;
			case "image/pjpeg":
			case "image/jpeg":
				$img = imagecreatefromjpeg($file);
				break;
		}
		if(!$img)
		{
			JError::raiseWarning(240, JText::_('Cannot create Image'), $file.$add);
			return ;
		}

		$mini  = imagecreatetruecolor($width, $height);
		$white = imagecolorallocate  ($mini,255,255,255);

		imagefilledrectangle($mini,0,0,$width,$height,$white);
		imagecopyresampled($mini,$img,0,0,0,0,$width,$height,$size[0],$size[1]);

		imagejpeg($mini, JPATH_CACHE.DS.$name, $quality);
		JFile::copy(JPATH_CACHE.DS.$name, $folder.DS.$name);
		@unlink(JPATH_CACHE.DS.$name);

		imagedestroy($mini);
		imagedestroy($img);
	}
}
?>
