<?php
/**
 * @version		$Id: article.php 11646 2009-03-01 19:34:56Z ian $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class Community_stuffsModelCommunity_stuffs extends JModel
{
	function Community_stuffsModelCommunity_stuffs()
	{
		parent::__construct();
	}

	function getStufflist($limitstart, $limit, $search, $type, &$total, $user_id=null) 
	{
		$db		  = &JFactory::getDBO();

		$where = array();
		if ($search!='') $where[] = 'sn.name LIKE '.$db->Quote('%'.$search.'%');
		if ($type>0 && $type<5) $where[] = 'st.type='.$type;
		$where = (count($where)>0) ? 'WHERE '.implode(' AND ',$where).' ' : '';
		$having = ($user_id>0) ? 'HAVING user_id='.$user_id.' ' : '';
		
		$userids = 'SELECT sn.id AS stnameid, sn.name, st.*, st.id AS stid '
				.'FROM #__community_stuffs AS st '
				.'LEFT JOIN #__community_stuff_names AS sn ON sn.id=st.stuff_name_id '
				.$where
				;
		
		$usernums = 'SELECT sn.id AS stnameid, COUNT(st.user_id) AS usernum '
				.'FROM #__community_stuffs AS st '
				.'LEFT JOIN #__community_stuff_names AS sn ON sn.id=st.stuff_name_id '
				.'GROUP BY stnameid '
				;
		$query = 'SELECT userids.* , usernums.usernum '
				."FROM ({$userids}) AS userids "
				."LEFT JOIN ({$usernums}) AS usernums ON userids.stnameid=usernums.stnameid "
				.$having
				.'ORDER BY name '
				;

		$db->setQuery($query);
		$stfs = $db->loadObjectList();

		$total = count($stfs);

		$newstfs = array();
		if (count($stfs)>0) {
			$i = 0;
			foreach ($stfs as $st) {
				if ($i>=$limitstart && $i<$limitstart+$limit) $newstfs[$st->id] = $st;
				$i++;
			}
		}
		$stfs = $newstfs;
		
		return $stfs;
	}

	function getUserName($uid) {
		$db		  = &JFactory::getDBO();		
		$db->setQuery('SELECT name FROM #__users WHERE id='.$uid);		
		return $db->loadResult();
	}
	
	function getTypeNames() {
		$db = &JFactory::getDBO();
		$db->setQuery("SELECT params FROM #__plugins WHERE element='community_stuffs'");
		$prs = $db->loadResult();
		$tn[0] = JText::_('TYPE0');
		preg_match("/(type1)=([^\n]*\n)/", $prs, $m);
		$tn[1] = $m[2];
		preg_match("/(type2)=([^\n]*\n)/", $prs, $m);
		$tn[2] = $m[2];
		preg_match("/(type3)=([^\n]*\n)/", $prs, $m);
		$tn[3] = $m[2];
		preg_match("/(type4)=([^\n]*\n)/", $prs, $m);
		$tn[4] = $m[2];
		return $tn;
	}
}
