<?php
/**
 * @version		$Id: view.html.php 11665 2009-03-08 20:30:23Z willebil $
 * @package		Joomla
 * @subpackage	Contact
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * @package		Joomla
 * @subpackage	Contacts
 */
class Community_stuffsViewCommunity_stuffs extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;

		$user	  = &JFactory::getUser();
		$uri 	  =& JFactory::getURI();
		$model	  = &$this->getModel();
		$document = & JFactory::getDocument();
		$document->addScript(JURI::root().'components/com_community/js/shadowbox/adapter/shadowbox-base.js');
		$document->addScript(JURI::root().'components/com_community/js/shadowbox/shadowbox.js');

		$pathway 	= & $mainframe->getPathway();
		$current = $pathway->getPathwayNames();
		$pathway->addItem('Stuffs', '');

		// Selected Request vars
		$limitstart			= JRequest::getVar('limitstart',		0,				'', 'int');
		$search				= JRequest::getVar('search',			'',				'', 'word');
		$type				= JRequest::getVar('type',				null,			'', 'int');
		$user_id			= JRequest::getVar('user_id',			-1,				'', 'int');
		
		jimport('joomla.filesystem.file');
		$params = new JParameter(JFile::read(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'config.ini'));
		$src = JURI::root().$params->get('general::upload');
		
		$limit = $mainframe->getUserStateFromRequest('limit', 'limit', 10, 'int');
		if ($limit<=0) {
			$mainframe->setUserState('limit', 10);
			$limit = 10;
		}
		$document->setTitle( JText::_('STUFFSEARCH'));
		$stfs = $model->getStufflist($limitstart, $limit, $search, $type, $total, $user_id);
		
		// build a drop down list for types
		$wh = array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0);
		switch ($type) 
		{
			case 1: $wh[1] = 1;  break;
			case 2: $wh[2] = 1;  break;
			case 3: $wh[3] = 1;  break;
			case 4: $wh[4] = 1;  break;
			default: $wh[0] = 1; break;
		}
	
		$tn = $model->getTypeNames();
		$typelist = '<select name="type"/>';
		for ($i=0; $i<5; $i++) 
			$typelist .= ($wh[$i]==1) ? '<option value="'.$i.'" selected>'.$tn[$i].'</option>'
								  : '<option value="'.$i.'">'.$tn[$i].'</option>';
		$typelist .= '</select>';
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);

		$action = 'index.php?option=com_community_stuffs&view=community_stuffs&Itemid='.JRequest::getInt('Itemid');
		$action.= ($user_id>0) ? '&user_id='.$user_id : '';
		$this->assignRef('pagination',	$pagination);
		$this->assign('action',		JRoute::_($action));
		$this->assign('stfs',		$stfs);
		$this->assign('typelist',	$typelist);
		$vars = ($type) ? '&type='.$type : '';
		$vars.= ($search) ? '&search='.$search : '';
		$this->assign('vars',		$vars);
		$this->assign('user_name',	$model->getUserName($user_id));
		$this->assign('user_id',	$user_id);
		$this->assign('src',		$src);
		$this->assign('params',		$params);
		$this->assign('tn',			$tn);
		
		parent::display($tpl);	
	}
}
